    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ----------
    028 * Block.java
    029 * ----------
    030 * (C) Copyright 2004-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 22-Oct-2004 : Version 1 (DG);
    038 * 08-Feb-2005 : Added ID (DG);
    039 * 20-Apr-2005 : Added a new draw() method that can accept params
    040 *               and return results (DG);
    041 *
    042 */
    043
    044package org.jfree.chart.block;
    045
    046import java.awt.Graphics2D;
    047import java.awt.geom.Rectangle2D;
    048
    049import org.jfree.ui.Drawable;
    050import org.jfree.ui.Size2D;
    051
    052/**
    053 * A block is an arbitrary item that can be drawn (in Java2D space) within a
    054 * rectangular area, has a preferred size, and can be arranged by an
    055 * {@link Arrangement} manager.
    056 */
    057public interface Block extends Drawable {
    058
    059    /**
    060     * Returns an ID for the block.
    061     *
    062     * @return An ID.
    063     */
    064    public String getID();
    065
    066    /**
    067     * Sets the ID for the block.
    068     *
    069     * @param id  the ID.
    070     */
    071    public void setID(String id);
    072
    073    /**
    074     * Arranges the contents of the block, with no constraints, and returns
    075     * the block size.
    076     *
    077     * @param g2  the graphics device.
    078     *
    079     * @return The size of the block.
    080     */
    081    public Size2D arrange(Graphics2D g2);
    082
    083    /**
    084     * Arranges the contents of the block, within the given constraints, and
    085     * returns the block size.
    086     *
    087     * @param g2  the graphics device.
    088     * @param constraint  the constraint (<code>null</code> not permitted).
    089     *
    090     * @return The block size (in Java2D units, never <code>null</code>).
    091     */
    092    public Size2D arrange(Graphics2D g2, RectangleConstraint constraint);
    093
    094    /**
    095     * Returns the current bounds of the block.
    096     *
    097     * @return The bounds.
    098     */
    099    public Rectangle2D getBounds();
    100
    101    /**
    102     * Sets the bounds of the block.
    103     *
    104     * @param bounds  the bounds.
    105     */
    106    public void setBounds(Rectangle2D bounds);
    107
    108    /**
    109     * Draws the block within the specified area.  Refer to the documentation
    110     * for the implementing class for information about the <code>params</code>
    111     * and return value supported.
    112     *
    113     * @param g2  the graphics device.
    114     * @param area  the area.
    115     * @param params  optional parameters (<code>null</code> permitted).
    116     *
    117     * @return An optional return value (possibly <code>null</code>).
    118     */
    119    public Object draw(Graphics2D g2, Rectangle2D area, Object params);
    120
    121}